//---------------------------------------------------------------------------
// ReInit.cpp - a translation of Borland's ReInit.pas into cpp
//  Translation by Kurt Fitzner <kfitzner@excelcia.org>
//  No copyright is asserted on this file.
//---------------------------------------------------------------------------
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>
#pragma hdrstop

#include "ReInit.h"
//---------------------------------------------------------------------------


HINSTANCE __fastcall SetResourceHInstance(HINSTANCE NewInstance)
{
  TLibModule *CurModule;

  CurModule = LibModuleList;
  while (CurModule) {
    if (CurModule->instance == (long)HInstance) {
      if (CurModule->resinstance != CurModule->instance)
        FreeLibrary((HINSTANCE)CurModule->resinstance);
      CurModule->resinstance = (long)NewInstance;
      return NewInstance;
    }  // if (CurModule->instance == HInstance)
    CurModule = CurModule->next;
  }  // while (CurModule)
  return NULL;
}  // int __fastcall SetResourceHInstance(HINSTANCE NewInstance)


HINSTANCE __fastcall LoadNewResourceModule(LCID Locale)
{
  char FileName[261];
  char * P;
  char LocaleName[5];
  HINSTANCE NewInst = NULL;

  GetModuleFileName(HInstance, FileName, sizeof(FileName));
  GetLocaleInfo(Locale, LOCALE_SABBREVLANGNAME, LocaleName, sizeof(LocaleName));
  P = FileName + strlen(FileName);
  for (P = FileName + strlen(FileName); P--; *P != '.' && P != FileName);
  if (P != FileName) {
    P++;
    if (*LocaleName) {
      // Then look for a potential language/country translation
      strcpy(P, LocaleName);
      NewInst = LoadLibraryEx(FileName, 0, LOAD_LIBRARY_AS_DATAFILE);
      if (!NewInst) {
        // Finally look for a language only translation
        LocaleName[2] = '\000';
        strcpy(P, LocaleName);
        NewInst = LoadLibraryEx(FileName, 0, LOAD_LIBRARY_AS_DATAFILE);
      }  // if (!NewInst)
    }  // if (*LocaleName)
  }  // if (P != FileName);
  if (NewInst)
    return SetResourceHInstance(NewInst);
  else
    return NULL;
}  // int __fastcall LoadNewResourceModule(LCID Locale)

/*
function InternalReloadComponentRes(const ResName: string; HInst: THandle; var Instance: TComponent): Boolean;
var
  HRsrc: THandle;
  ResStream: TResourceStream;
  AsInheritedReader: TAsInheritedReader;
begin                   { avoid possible EResNotFound exception }
  if HInst = 0 then HInst := HInstance;
  HRsrc := FindResource(HInst, PChar(ResName), RT_RCDATA);
  Result := HRsrc <> 0;
  if not Result then Exit;
  ResStream := TResourceStream.Create(HInst, ResName, RT_RCDATA);
  try
    AsInheritedReader := TAsInheritedReader.Create(ResStream, 4096);
    try
      Instance := AsInheritedReader.ReadRootComponent(Instance);
    finally
      AsInheritedReader.Free;
    end;
  finally
    ResStream.Free;
  end;
  Result := True;
end;
*/
bool InternalReloadComponentRes(AnsiString ResName, THandle HInst, TComponent *


bool ReloadInheritedComponent(TComponent *Instance, TMetaClass *ClassType, TMetaClass *RootAncestor)
{
  bool retval;

  if (ClassType == __classid(TComponent) || ClassType == RootAncestor)
    return false;
  retval = ReloadInheritedComponent(Instance, ClassType->ClassParent(), RootAncestor);
  retval |= InternalReloadComponentRes(ClassType->ClassName(), FindResourceHInstance(FindClassHInstance(ClassType)), Instance);
  return retval;
}  // bool ReloadInheritedComponent(TComponent *Instance, TMetaClass *ClassType, TMetaClass *RootAncestor)


void __fastcall ReinitializeForms(void)
{
  for (int n = 0; n < Screen->FormCount; n++)
    ReloadInheritedComponent(Screen->Forms[n], Screen->Forms[n]->ClassType(), __classid(TForm));
}  // void __fastcall ReinitializeForms(void)


